/* bk04r3.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int bk04r3_c(real *gammcf, real *a, real *x, real *gln)
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Builtin functions */
    double log(doublereal), exp(doublereal);

    /* Local variables */
    static real gold;
    extern real bk04r4_c(real *);
    static real g;
    static integer n;
    static real a0;
    static integer itmax;
    static real a1, b0, b1, an, fac, ana, anf, eps;

    itmax = 100;
    eps = 3e-7f;
    *gln = (real)bk04r4_c(a);
    gold = 0.f;
    a0 = 1.f;
    a1 = *x;
    b0 = 0.f;
    b1 = 1.f;
    fac = 1.f;
    i__1 = itmax;
    for (n = 1; n <= i__1; ++n) {
        an = (real) n;
        ana = an - *a;
        a0 = (a1 + a0 * ana) * fac;
        b0 = (b1 + b0 * ana) * fac;
        anf = an * fac;
        a1 = *x * a0 + anf * a1;
        b1 = *x * b0 + anf * b1;
        if (a1 == 0.f) {
            goto L11;
        }
        fac = 1.f / a1;
        g = b1 * fac;
        if ((r__1 = (g - gold) / g, abs(r__1)) < eps) {
            goto L1;
        }
        gold = g;
L11:
        ;
    }
/*      PAUSE 'A too large, ITMAX too small' */
L1:
    *gammcf = (real)exp((real)(-(*x) + *a * (real)log(*x) - *gln)) * g;
    return 0;
} /* bk04r3_c */
